<template>
  <v-row justify="start" align="center">
    <v-col cols="12" sm="8" md="6">
      <v-card-title>
        <v-text-field
          v-model="search"
          append-icon="mdi-magnify"
          label="Search"
          single-line
          hide-details
          @keyup.enter="searchText(search)"
        ></v-text-field>
      </v-card-title>
      <template v-if="!loading && list.length > 0">
        <v-card v-for="(item, i) in list" :key="i">
          <v-list-item>
            <v-list-item-content>
              <v-list-item-title>{{ item.primaryLabel }}</v-list-item-title>
              <v-list-item-subtitle>{{ item.primaryID }}</v-list-item-subtitle>
              <v-list-item-content>{{
                item.textualDefinitions[0]
              }}</v-list-item-content>
            </v-list-item-content>
          </v-list-item> 
          <v-divider></v-divider>
        </v-card>
        <v-spacer></v-spacer>
      </template>
      <template v-else-if="list.length === 0 && !loading">
        <v-banner elevation="6" single-line sticky>No result</v-banner>
      </template>
      <template v-else>
        <v-overlay :value="loading">
          <v-progress-circular indeterminate size="64"></v-progress-circular>
        </v-overlay>
      </template>
      <v-pagination
        v-model="page"
        :length="pageCount"
        :total-visible="5"
        @input="pageChange"
      ></v-pagination>
    </v-col>
  </v-row>
</template>
<script>
import axios from 'axios'

export default {
  data() {
    return {
      token:'',
      search: '',
      list: [],
      page: 1,
      pageSize: 10,
      pageCount: 0,
      loading: false,
    }
  },
  head() {
    return {
      title: 'Welcome To Scibite',
      meta: [
        {
          hid: 'description',
          name: 'description',
          content: 'Quick and easy serach',
        },
      ],
    }
  },
  methods: {
    async searchText(text) {
      this.loading = true

      const config = {
        headers: { Authorization: `Bearer ${this.token}` },
      }

      try {
        const res = await axios.get(
          `https://demo.centree.scibite.io/api/search?q=${this.search}&size=${this.pageSize}&from=${this.page}`,
          config
        )
        this.list = res.data.elements
        this.pageCount = Math.round(res.data.total / this.pageSize)
        this.loading = false
      } catch (err) {
        console.log(err)
      }
    },
    pageChange(event) {
      this.searchText(this.search)
    },
  },
}
</script>